
const RoleServices = require('../Services/Role.services');

/**
 * @description This is used for check or compare permission 
 * @param {*} req.params.role from that get role name 
 * @param {*} res 
 * @returns Object { status: true, message: String }
 * - { status : false, error : string }
 */
module.exports.permission = async (req, res) => {
    try {
        const user = req.local.user;
        const role = req.query.role;

        // console.log(role)
        // console.log(user.permission, " ================ user permission ==================");

        const RoleResult = await RoleServices.findByRoleName({ name: role });
        if (!RoleResult.status || RoleResult.error) return res.status(500).send(RoleResult);

        var rolePermission = RoleResult.roles.permission;

        // console.log(rolePermission, " ================ role permission ==================");

        let flag = true;
        for (property in user.permission) {
            for (key in rolePermission) {
                if (key == property) {
                    for (i = 0; i < rolePermission[key].length; i++) {
                        if (rolePermission[key][i] != user.permission[key][i]) {
                            if (user.permission[key][i] != '1') {
                                flag = false;
                            }
                        }
                    }
                }
            }
        }
        if (flag) {
            return res.status(200).send({ status: true });
        }
        else {
            return res.status(200).send({ status: false });
        }
    }
    catch (e) {
        console.log(e);
        return res.status(500).send({ status: false, error: 'Internal Server Error!' });
    }
};
