const OrganizationServices = require('../Services/Organization.services');

module.exports = async (req, res, next) => {

    const user = req.local.user;
    const orgId = req.params.orgId;
    const branchId = req.params.branchId || null;

    const OrganizationResult = await OrganizationServices.findAll({ '_id': { $in: [orgId, branchId] } }, {});
    if (!OrganizationResult.status || OrganizationResult.error) return res.status(500).send(OrganizationResult);

    console.log("org => ", OrganizationResult);
    try {
        if (OrganizationResult.Organizations.length > 0 && OrganizationResult.Organizations.reduce((prev, curr) => [...prev, ...curr.owners.map((val, id) => val._id)], []).includes(user._id)) {
            next()
        } else {
            return res.status(401).send({ status: false, message: "logged out!" })
        }
    }
    catch (e) {
        console.log("🚀 ~ file: isBranchAdmin.js:25 ~ module.exports= ~ e:", e)
        return res.status(401).send({ status: false, message: "failed to verify role. Please contact admin." })
    }

}