const mongoose = require('mongoose');

const Schema = mongoose.Schema;

const attendanceSchema = Schema({
    userId: {
        type: Schema.Types.ObjectId,
        ref: 'User',
    },
    orgId: {
        type: Schema.Types.ObjectId,
        ref: 'Organization',
    },
    date: {
        type: Date
    },
    login: [{
        time: {
            type: Date
        },
        type: {
            type: String //ENTRY, EXIT
        }
    }],
    leaveId: {
        type: Schema.Types.ObjectId,
        ref: 'Leave'
    },
    leaveReason: {
        type: String // HOLIDAY, SICK, GENERAL
    },
    present: {
        type: Boolean
    },
    status: {
        type: Boolean
    },

}, { timestamps: true });

module.exports = mongoose.model('Attendance', attendanceSchema);