const mongoose = require('mongoose');
const Schema = mongoose.Schema;

const branchSchema = Schema({
    type: {
        type: String
    },
    zone: {
        _id: {
            type: String
        },
        client: {
            _id: {
                type: String,
                // type: Schema.Types.ObjectId,
                // ref: 'User'
            },
            type: {
                type: String
            },
            sugar_client_id: {
                type: String
            },
            name: {
                type: String
            },
            phone: {
                type: String
            },
            displayName: {
                type: String,
            },
            initial: {
                type: String
            },
            uniqueId: {
                type: String
            },
            email: {
                type: String
            }
        },
        zoneName: {
            type: String
        },
        feeStructure: [{
            type: String
        }]
    },
    typeOfFees: {
        type: String
    },
    deactivatedCreditOfficer: [{
        type: String
    }],
    fees: {
        assetsClass: { // 1) Land & Building / Immovable Property  2) Plant & Machinery  3) Securities or Financial Assets
            type: String
        },
        feeStructure: {
            propertyType: [{
                type: String
            }],
            feeStructureObject: {
                type: Object
            }
        },
    },
    sugar_client_id: {
        type: String
    },
    sugar_branch_id: {
        type: String
    },
    sugar_unique_id: {
        type: String
    },
    branchCode: {
        type: String
    },
    name: {
        type: String,
    },
    email: {
        type: String,
    },
    mobileNo: {
        type: String,
    },
    alternateMobileNo: {
        type: String
    },
    address: {
        type: String,
    },
    isdelete: {
        type: Boolean,
        default: false
    },
    status: {
        type: Boolean,
        default: true
    },
    sendStructuralCertificate: {
        type: String,
    },
    sendStructuralReport: {
        type: String,
    },
    ledgerName: {
        type: String,
    },
    fax: {
        type: String
    },
    description: {
        type: String
    },
    docs: [{
        name: String,
        fileType: String,
    }],
    organization: {
        _id: {
            type: String,
            // type: Schema.Types.ObjectId,
            // ref: 'Organization'
        },
        name: {
            type: String
        },
        email: {
            type: String
        },
        shortName: {
            type: String
        },
        address: {
            type: String
        },
        gstNo: {
            type: String
        },
        type: {
            type: String
        },
        ownerName: {
            type: String
        },
        ownerLastName: {
            type: String
        },
        ownerFatherName: {
            type: String
        },
        ownerEmail: {
            type: String
        },
        panNo: {
            type: String
        },
        phone: {
            type: String
        },
        profilePhoto: {
            type: String
        },
        city: {
            type: String
        },
        organization: {
            _id: {
                type: String
            },
            name: {
                type: String
            },
            email: {
                type: String
            },
            gstNo: {
                type: String
            }
        },
    },
    pickupPerson: {
        _id: {
            type: String
            // type: Schema.Types.ObjectId,
            // ref: 'User',
        },
        firstName: {
            type: String,
        },
        lastName: {
            type: String,
        },
        shortName: {
            type: String,
        },
        email: {
            type: String,
        },
        alternateEmail: {
            type: String
        },
        designation: {
            type: String
        },
        mobileNo: {
            type: String,
        },
        workMobileNo: {
            type: String,
        },
        salutation: {
            type: String,
        },
        fax: {
            type: String,
        },
        role: {
            type: String
        },
        reportTo: {
            type: String
        },
        isdelete: {
            type: Boolean
        },
        status: {
            type: Boolean
        }
    },
    client: {
        _id: {
            type: String
        },
        type: {
            type: String,
        },
        sugar_client_id: {
            type: String
        },
        name: {
            type: String,
        },
        displayName: {
            type: String,
        },
        initial: {
            type: String
        },
        clientKey: {
            type: String
        },
        remark: {
            type: String
        },
        isdelete: {
            type: Boolean
        },
        status: {
            type: Boolean
        }
    }
}, { timestamps: true });

branchSchema.methods.addCreditOfficer = async function (obj) {
    // console.log("credit officer in model ==============", this.creditOfficer);
    this.creditOfficer.push(obj);
    return this.save();

};
module.exports = mongoose.model('Branch', branchSchema);