const mongoose = require('mongoose');
const Schema = mongoose.Schema;

const userSchema = {
    _id: {
        type: Schema.Types.ObjectId,
        ref: 'User',
    },
    firstName: String,
    lastName: String,
    profilePhoto: String,
};

const permissionSchema = {
    access: {
        value: Boolean,
        default: false
    },
    list: {
        value: Boolean,
        default: false
    },
    view: {
        value: Boolean,
        default: false
    },
    create: {
        value: Boolean,
        default: false
    },
    edit: {
        value: Boolean,
        default: false
    },
    delete: {
        value: Boolean,
        default: false
    },
    export: {
        value: Boolean,
        default: false
    },
    import: {
        value: Boolean,
        default: false
    }

};

module.exports = { userSchema, permissionSchema, }