
const mongoose = require('mongoose');

const Schema = mongoose.Schema;

const CreateContactSchema = Schema({
    type: {
        type: String
    },
    details: {
        type: String
    },
    image: [{
        type: String
    }],
    status: {
        type: String,
        default: "TRUE"
    },
    createStatus: {
        type: String,
        default: "FALSE"
    },
    createdBy: {
        _id: {
            type: String
        },
        firstName: {
            type: String,
        },
        lastName: {
            type: String,
        },
        mobileNo: {
            type: String,
        },
        email: {
            type: String,
        }

    },
    organizationId: {
        type: Schema.Types.ObjectId,
        ref: 'Organization'
    },
    createDate: {
        type: String
    }
}, { timestamps: true });

module.exports = mongoose.model('CreateContact', CreateContactSchema);