const mongoose = require('mongoose');

const Schema = mongoose.Schema;

const MailLog = Schema({
    emails: [{ type: String }],
    cc: [{ type: String }],
    bcc: [{ type: String }],
    body: { type: String },
    type: { type: String }, // ADVANCE_INVOICE, SIGNED_REPORT_UPLOAD, PROFORMA_INVOICE, DRAFT_REPORT
    attachments: [{
        // _id: false,
        // id: String,
        // originalname: String,
        // fileName: String,
        // documentType: {},
        // path: String,
    }],
    case: {
        _id: {
            type: Schema.Types.ObjectId,
            ref: 'Case',
        },
        caseNumber: {
            type: String
        },
        typeOfReport: {
            value: { type: String },
            label: { type: String }
        },
        ownerName: {
            type: String
        },
        clientType: {
            value: {
                type: String
            },
            label: {
                type: String
            }
        }
    },
    otherInfo: {},
    status: { type: String },
    sentBy: {
        _id: false,
        userId: {
            type: Schema.Types.ObjectId,
            ref: 'User',
        },
        firstName: { type: String },
        lastName: { type: String },
        role: { type: String },
    },
    mailResponse: {
        accepted: [{ type: String }],
        rejected: [{ type: String }],
        response: { type: String },
        messageId: { type: String }
    }
}, { timestamps: true });

module.exports = mongoose.model('MailLog', MailLog);