const mongoose = require('mongoose');
const BranchServices = require('../Services/Branch.services');
const Schema = mongoose.Schema;

const transferBranchHistorySchema = Schema({
    newBranch: {
        _id: {
            type: String
        },
        type: {
            type: String
        },
        name: {
            type: String,
        },
        email: {
            type: String,
        },
        mobileNo: {
            type: String,
        },
        address: {
            type: String,
        },
        client: {
            _id: {
                type: String
            },
            type: {
                type: String,
            },
            name: {
                type: String,
            },
            displayName: {
                type: String,
            },
            initial: {
                type: String
            }
        }
    },
    oldBranch: {
        _id: {
            type: String
        },
        type: {
            type: String
        },
        name: {
            type: String,
        },
        email: {
            type: String,
        },
        mobileNo: {
            type: String,
        },
        address: {
            type: String,
        },
        client: {
            _id: {
                type: String
            },
            type: {
                type: String,
            },
            name: {
                type: String,
            },
            displayName: {
                type: String,
            },
            initial: {
                type: String
            }
        }
    },
    organization: {
        _id: {
            type: String,
            // type: Schema.Types.ObjectId,
            // ref: 'Organization'
        },
        name: {
            type: String
        },
        email: {
            type: String
        },
        address: {
            type: String
        },
        gstNo: {
            type: String
        },
        type: {
            type: String
        },
        ownerName: {
            type: String
        },
        ownerLastName: {
            type: String
        },
        ownerFatherName: {
            type: String
        },
        ownerEmail: {
            type: String
        },
        phone: {
            type: String
        },
        city: {
            type: String
        },
        organization: {
            _id: {
                type: String
            },
            name: {
                type: String
            },
            email: {
                type: String
            },
            gstNo: {
                type: String
            }
        },
    },
    creditOfficer: {
        _id: {
            type: String,
            // type: Schema.Types.ObjectId,
            // ref: 'User'
        },
        profilePhoto: {
            type: String
        },
        firstName: {
            type: String,
        },
        lastName: {
            type: String,
        },
        shortName: {
            type: String,
        },
        email: {
            type: String,
        },
        mobileNo: {
            type: String,
        },
        type: {
            type: String,
        },
        branch: {
            _id: {
                type: String
            }
        }
    },
    dateTime: {
        type: String
    },
    caseCount: {
        type: String
    },
    caseList: [{
        type: String
    }]

}, { timestamps: true });

module.exports = mongoose.model('TransferBranchHistory', transferBranchHistorySchema);