
const mongoose = require('mongoose');

const Schema = mongoose.Schema;

const zoneSchema = Schema({

    client: {
        _id: {
            type: String,
            // type: Schema.Types.ObjectId,
            // ref: 'User'
        },
        type: {
            type: String,
            required: true
        },
        name: {
            type: String,
            required: true
        },
        phone: {
            type: String
        },
        displayName: {
            type: String,
        },
        initial: {
            type: String
        },
        uniqueId: {
            type: String
        },
        email: {
            type: String
        },
        ledgerName: {
            type: String
        },
        remark: {
            type: String
        },
        address: {

            street: {
                type: String
            },
            city: {
                type: String
            },
            state: {
                type: String
            },
            postalCode: {
                type: String
            },
            country: {
                type: String
            },
        }
    },
    organization: {
        _id: {
            type: String
        },
        name: {
            type: String
        },
        email: {
            type: String
        },
        shortName: {
            type: String
        },
        address: {
            type: String
        },
        freeCases: {
            type: String
        },
        gstNo: {
            type: String
        },
        panNo: {
            type: String
        },
        type: {
            type: String
        },
        phone: {
            type: String
        },
        profilePhoto: {
            type: String
        },
        status: {
            type: Boolean,
            default: true
        },
        isdelete: {
            type: Boolean,
            default: false
        },
        expiryDate: {
            type: Date
        },
        city: {
            type: String
        },
        organization: {
            _id: {
                type: String
            },
            name: {
                type: String
            },
            email: {
                type: String
            },
            gstNo: {
                type: String
            }
        }
    },
    zoneName: {
        type: String
    },
    // valuers: [{
    //     _id: {
    //         type: String
    //         // type: Schema.Types.ObjectId,
    //         // ref: 'User'
    //     },
    //     firstName: {
    //         type: String,
    //     },
    //     fatherName: {
    //         type: String
    //     },
    //     PANNo: {
    //         type: String
    //     },
    //     lastName: {
    //         type: String,
    //     },
    //     profilePhoto: {
    //         type: String,
    //     },
    //     shortName: {
    //         type: String,
    //     },
    //     email: {
    //         type: String,
    //     },
    //     designation: {
    //         type: String
    //     },
    //     mobileNo: {
    //         type: String,
    //     },
    //     role: {
    //         type: String
    //     },
    //     type: {
    //         type: String,
    //     },
    //     registrationNo: [{
    //         title: {
    //             value: {
    //                 type: String
    //             },
    //             label: {
    //                 type: String
    //             }
    //         },
    //         number: {
    //             type: String
    //         }
    //     }],
    //     zoneEmpanelment: [{
    //         empanelmentNo: {
    //             type: String
    //         },
    //         isDelete: {
    //             type: Boolean,
    //             default: false
    //         },
    //         fileType: {
    //             type: String
    //         },
    //         startDate: {
    //             type: String
    //         },
    //         endDate: {
    //             type: String
    //         },
    //         feeStructure: {
    //             propertyType: [{
    //                 type: String
    //             }],
    //             feeStructureObject: {
    //                 type: Object
    //             }
    //         },
    //         empanelmentLetter: [{
    //             type: Object
    //         }],
    //         masterTypeOfPurpose: {

    //             type: String

    //         },
    //         assetsClass: { // 1) Land & Building / Immovable Property  2) Plant & Machinery  3) Securities or Financial Assets

    //             type: String

    //         }
    //     }]
    // }]

}, { timestamps: true });

module.exports = mongoose.model('Zone', zoneSchema);