const { MongoClient, ObjectId } = require('mongodb');
const fs = require('fs');
const CDN = '../CDN/';
var args = process.argv.slice(2);

async function main() {

    const client = new MongoClient("mongodb://192.168.1.99:27017");
    try {
        // Connect to the MongoDB cluster
        await client.connect();
        const cases = client.db('realvalue').collection("cases");

        if (args[0] == "case") {
            const caseId = args[1];
            const c = await cases.findOne({ _id: ObjectId(args[1]) });
            const comAry = c.composition.reduce((prev, curr) => [...prev, ...curr.images], []) // done
            const ocomAry = c.otherComposition.reduce((prev, curr) => [...prev, ...curr.images], []) // done
            const indAry = c.indicatorArr.reduce((prev, curr) => [...prev, { ...curr, path: curr.image }], []);  // done
            const routeAry = c.routeMap.locationMapImg.reduce((prev, curr) => [...prev, { ...curr, path: curr.image }], []);  // done
            const reportImages = [
                ...c.reportImages.frontPageImages,
                ...c.reportImages.selfieWithSiteVisitImages,
                ...c.reportImages.parkingImages,
                ...c.reportImages.societyNameBoardImage,
                ...c.reportImages.compositionImages,
                ...c.reportImages.externalPhotos
            ];

            const files = [
                ...c.externalImages,  // done
                ...comAry, ...ocomAry,
                ...c.externalReport,  // done
                ...c.documents, // done
                ...c.images,     // done
                ...indAry, ...routeAry,
                { path: c.routeMap.routeMapDetail?.routeMapImg },  // done
                { path: c.igrRate?.igrImage },  // done
                ...reportImages, // done
                ...c.externalDocuments, // done
                ...c.processingDocuments, // done
            ];

            const caseFiles = files.map((fils, i) => fils.path).filter((fils, i) => (!!fils && fils !== ""));
            console.log('caseFiles: ', caseFiles);
            const listDir = fs.readdirSync(CDN + 'cases/' + caseId, { withFileTypes: true }).map(dirent => dirent.name)
            listDir.map((d, id) => {
                const hasFile = caseFiles.includes('cases/' + caseId + '/' + d);
                // !hasFile && fs.unlinkSync(CDN + 'cases/' + caseId + "/" + d)
                console.log("path => ", hasFile, " = ", d);
            });

            console.log("🚀 ~ file: clean_storage.js:20 ~ main ~ files:",);
        }
        // else if (args[0] == "cases") {

        //     const ce = await cases.find({}, { projection: { _id: 1, caseNumber: 1, documents: 1 } }).toArray();

        //     const listDir = fs.readdirSync(CDN + '/cases/', { withFileTypes: true }).filter(dirent => dirent.isDirectory()).map(dirent => dirent.name)
        //     // console.log("Dir: ", listDir);
        //     let c = { new: 0, old: 0 };
        //     listDir.map((d, id) => {
        //         if (ce.filter((casee, id) => casee._id == d).length > 0) { c.new += 1; console.log("- ", d) }
        //         else {
        //             c.old += 1; console.log("DELETE", d, "old: ", CDN + '/cases/' + d, "new: ", CDN + '/cases/old_' + d);
        //             //  fs.rename(CDN+'/cases/'+d, CDN+'/cases/old_'+d, function(err) {
        //             //     if (err) {
        //             //       console.log(err)
        //             //     } else {
        //             //       console.log("Successfully renamed the directory. ",d)
        //             //     }
        //             //   })
        //         }
        //     })
        //     console.log("c: ", c);
        // }
    } catch (e) {
        console.error(e);
    } finally {
        await client.close();
    }
}

main().catch(console.error);