const express = require('express');
const router = express.Router();
const ApprovalRequestController = require('../Controllers/ApprovalRequest.controller');
const isAuth = require('../Middleware/isAuth');
const pagination = require('../Middleware/pagination');
const validation = require('../Middleware/validation');

// For list all approval-requests 
router.get('/approval-request-count', isAuth, ApprovalRequestController.getDashboardCount);
router.get('/approval-request', isAuth, pagination, ApprovalRequestController.getAll);

// For get one approval-request 
router.get('/approval-request/:id', isAuth, ApprovalRequestController.get);

// For create new approval-request
router.post('/approval-request', isAuth, validation.ApprovalRequestValidation, ApprovalRequestController.create);

// For update approval-request 
router.put('/approval-request/:id/:status', isAuth, validation.ApprovalRequestValidation, ApprovalRequestController.update);

module.exports = router;

