const express = require('express');
const router = express.Router();
const BugTicketController = require('../Controllers/BugTicket.controller');
const isAuth = require('../Middleware/isAuth');
const pagination = require('../Middleware/pagination');
const isPermission = require('../Middleware/isPermission');
const uploadFile = require('../Middleware/uploadFile');
const validation = require('../Middleware/validation');

// For list all Clients 
router.get('/Tickets', isAuth, pagination, BugTicketController.getAll);

// For get one client 
router.get('/Tickets/:id', isAuth, BugTicketController.get);

// For create new Client
router.post('/Tickets', isAuth, uploadFile.audioRemarks, validation.bugTicketValidation, BugTicketController.createTicket);

// For update Client 
router.put('/Tickets/:id', isAuth, uploadFile.audioRemarks, validation.bugTicketValidation, BugTicketController.updateTicket);

module.exports = router;

