const express = require("express");
const router = express.Router();

const multer = require('multer');
const fs = require('fs');
const path = require('path');
const unzipper = require('unzipper');
const { logger } = require('../logger');
const { PROJECT_DIR } = require('../path');

// Define the directory where files will be uploaded and unzipped
const UPLOAD_DIR = path.join(PROJECT_DIR, 'public', 'development-zip');

// Ensure the directories exist
if (!fs.existsSync(UPLOAD_DIR)) fs.mkdirSync(UPLOAD_DIR, { recursive: true });


const fileStorage = multer.diskStorage({
    destination: (req, file, cb) => {
        // ================================== For  upload Empanelment Letter ========================================
        if (!fs.existsSync(UPLOAD_DIR)) { fs.mkdirSync(UPLOAD_DIR, { recursive: true }); }
        if (file.fieldname === 'file') { cb(null, UPLOAD_DIR); }
    },
    filename: (req, file, cb) => {

        let fileName = file.originalname;
        // get the extension from filename using javascript
        var ext = fileName.substr(fileName.lastIndexOf('.') + 1);

        // get file name without extension
        fileName = fileName.split('.').slice(0, -1).join('.')

        let FileName = fileName.replace(/[^\w\s]/gi, '');
        let originalFileName = FileName + "." + ext;

        cb(null, Date.now() + '_' + originalFileName.split(' ').join('_'));
    }
});


router.post('/dev/deployment-build',
    multer({ storage: fileStorage }).single('file'),
    async (req, res) => {
        try {

            const authToken = req.headers['Authorization'] || req.headers['authorization'];
            console.log("=> ", authToken, JSON.stringify(req.file), JSON.stringify(req.files));
            if (authToken.replace('Bearer ', '') !== "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJfaWQiOiI2MGFmNDE4NTJmZmRmNjViY2Q2NTg1ZDQiLCJlbWFpbCI6ImRhcnNoYW5Ac29taW5mb3RlY2guY29tIiwiaWF0IjoxNzI1MDQ0MTcyLCJleHAiOjE3MjU2NDg5NzJ9.YrdN1ERmV9sy8ZuL8XTUVbwwUVNpripUA55HlqSaOHc") {
                return res.status(401).json({ message: 'Unauthorized' });
            }
            const uFilePath = req.file.path
            const UNZIP_DIR = path.join(PROJECT_DIR, '..', 'staging.vastukala.co.in', 'public_html');
            if (!fs.existsSync(UNZIP_DIR)) { return res.status(401).send({ status: false, error: "No Directory found" }); };

            await fs.createReadStream(uFilePath).pipe(unzipper.Extract({ path: UNZIP_DIR })).promise();

            return res.status(200).send({ status: true });
        } catch (e) {
            console.log(e);
            logger.error(`Error occured in development deploy: ${e.toString()}`)
            return res.status(200).send({ status: false, error: e.toString() });
        }
    });

module.exports = router;