const express = require('express');
const router = express.Router();

const isAuth = require('../Middleware/isAuth');
const isAdmin = require('../Middleware/isAdmin');
const uploadFile = require('../Middleware/uploadFile');
const pagination = require('../Middleware/pagination');
const isPermission = require('../Middleware/isPermission');
const validation = require('../Middleware/validation');

const InvoiceController = require('../Controllers/Invoice.controller');

// For get list of all Invoices
// router.get('/invoices', isAuth, (req, res, next) => { return isPermission(req, res, next, { name: "Bill", value: "list" }) }, pagination, InvoiceController.getAllInvoices);

// For get only One Invoice
// router.get('/invoices/:id', isAuth, (req, res, next) => { return isPermission(req, res, next, { name: "Bill", value: "view" }) }, InvoiceController.getInvoice);

//For create new Invoice
// router.post('/requestInvoices', isAuth, validation.invoiceCreateValidation, InvoiceController.createInvoiceRequest);

// For update Invoice
// router.put('/invoices/:id', isAuth, (req, res, next) => { return isPermission(req, res, next, { name: "Bill", value: "edit" }) }, validation.updateInvoiceValidation, InvoiceController.updateInvoice);

// upload requested invoice
// router.put('/uploadInvoice/:id', isAuth, (req, res, next) => { return isPermission(req, res, next, { name: "Bill", value: "edit" }) }, uploadFile.uploadInvoice, validation.uploadInvoiceValidation, InvoiceController.invoiceUpload);

// not tested
// router.get('/convert-new-invoices', pagination, InvoiceController.getMultipleInvoices);
// router.put('/delete-invoice/:id/:subId', isAuth, (req, res, next) => { return isPermission(req, res, next, { name: "Bill", value: "edit" }) }, InvoiceController.deleteSubInvoice);

// router.get('/old-delete-duplicate-invoices', pagination, InvoiceController.oldDeleteDuplicateInvoice);

// router.get('/delete-duplicate-invoices', pagination, InvoiceController.deleteDuplicateInvoice);

module.exports = router;