const express = require('express');
const router = express.Router();
const PackageController = require('../Controllers/Package.controller');
const isAuth = require('../Middleware/isAuth');
const isAdmin = require('../Middleware/isAdmin');
const isSuperAdmin = require('../Middleware/isSuperAdmin');
const isPermission = require('../Middleware/isPermission');
const validation = require('../Middleware/validation');

// For get list of all packages
router.get('/packages', isAuth, isSuperAdmin, PackageController.getAllPackages);

// For get only one package
router.get('/packages/:id', isAuth, isSuperAdmin, PackageController.getPackage);

// For create new package 
router.post('/packages', isAuth, isSuperAdmin, validation.packageValidation, PackageController.createPackage);

// For update Package
router.put('/packages/:id', isAuth, isSuperAdmin, validation.packageValidation, PackageController.updatePackage);

module.exports = router;